<template>
    <aside class="menu" id='menu'>
        <div v-bind:style="{ 
            backgroundImage: 'url(img/styles/' + map.mapStyle + '.png)' 
        }" class="has-text-centered has-rounded-corners">
            <h1 class="title is-1 has-padding">
                Mapview
            </h1>
        </div>

        <a v-on:click='demo()' class="menu-element button is-dark is-outlined is-rounded is-medium is-fullwidth">
            <icon-base class="has-small-margin" name='PLAY_CIRCLE' />
            Demo
        </a>

        <div class="menu-element columns is-mobile">
            <div 
                v-bind:key="key"
                v-for="(style, key) in STYLES"
                v-on:click="map.setMapStyle(key)"
                class="column is-paddingless has-small-margin has-background-light tile-frame has-background-transition"
            >
                <div v-bind:style="{ backgroundImage: 'url(img/styles/' + key.toLowerCase() + '.png)' }" class="tile" />
            </div>
        </div>

        <b-field class="menu-element">
            <b-upload v-model="dragAndDropFiles"
                v-on:input="upload"
                multiple
                drag-drop
            >
                <section class="section has-rounded-corners has-borders is-dashed">
                    <div class="content has-text-centered">
                        <div>
                            <icon-base v-bind:name="dragAndDropIcon" size="42" stroke="#bbbbbb" strokeWidth="2" />
                            <p v-html="dragAndDropText" />
                        </div>
                    </div>
                </section>
            </b-upload>
        </b-field>

        <div class="menu-element columns is-gapless is-mobile has-text-centered">
            <div class="column">
                <a v-on:click='map.clean()' class='navbar-item is-block'>
                    <icon-base name='TRASH' />
                    Clear
                </a>
            </div>
            <div class="column">
                <a v-on:click='save()' class='navbar-item is-block'>
                    <icon-base name='ARCHIVE' />
                    Save
                </a>
            </div>
            <div class="column">
                <a v-on:click='save()' class='navbar-item is-block'>
                    <icon-base name='EXCEL' />
                    Export
                </a>
            </div>
        </div>

        <div class="has-background-light has-rounded-corners has-small-padding is-relative live-box" id="live">
            <div class="has-text-weight-bold is-size-7 has-text-dark-red is-in-top-right-corner">
                <span class="dot has-background-dark-red"></span>
                live
            </div>

            <focused />

        </div>
    </aside>
</template>

<script lang='ts'>
    import { Component, Vue } from 'vue-property-decorator';
    import { State } from 'vuex-class';
    import Focused from './Focused.vue';
    import IconBase from './IconBase.vue';

    import * as CircularJSON from 'circular-json';
    import { STYLES } from '@/ts/enums';
    import { VERSION } from '@/ts/constants';
    import { Importer } from '@/ts/importer';
    import { Mapview } from '@/ts/mapview';

    @Component({
        components: {
            Focused,
            IconBase,
        },
    })
    export default class Menu extends Vue {
        @State('map') private map!: Mapview;

        private STYLES: typeof STYLES = STYLES;
        private dragAndDropFiles: File[] = [];
        private dragAndDropIcon: string = 'DOWNLOAD';
        private dragAndDropText: string = '<b>Choose a file</b> or drag it here';

        private demo(): void {
            new Importer().readTestFile(this.map);
        }

        private upload(): void {
            const nbErrors: number = 0;
            this.dragAndDropFiles.forEach((file: File) => {
                new Importer().readFile(this.map, file);
                // if (! new Importer().readFile(this.map, file)) {
                //     nbErrors++;
                // }
            });
            if (nbErrors === 0) {
                this.dragAndDropText = 'Done ! <b>Upload more ?</b>';
                this.dragAndDropIcon = 'CHECK';
            } else {
                this.dragAndDropText = String(nbErrors) + ' Error(s) ! <b>Upload more ?</b>';
                this.dragAndDropIcon = 'X';
            }
            this.dragAndDropFiles = new Array();
        }

        private save(): void {
            if (this.map._mapboxMap) {
                this.map.mapCenter = this.map._mapboxMap.getCenter();
                this.map.mapZoom = this.map._mapboxMap.getZoom();
            }

            const DATA: string = CircularJSON.stringify(this.map, (key: any, value: any): any => {
                const REGEXP: RegExp = new RegExp('^_.*$');
                if (REGEXP.test(key)) {
                    return undefined;
                }
                return value;
            }, '    ');

            const BLOB: Blob = new Blob([DATA], {type: 'text/plain'});
            const EVENT: any = document.createEvent('MouseEvents');
            const ANCHOR: HTMLAnchorElement = document.createElement('a');
            ANCHOR.download = 'save.json';
            ANCHOR.href = window.URL.createObjectURL(BLOB);
            EVENT.initEvent('click');
            ANCHOR.dispatchEvent(EVENT);
        }
    }
</script>

<style scoped>
    .menu-element {
        margin-top: 0.5em !important;
        margin-bottom: 0.5em !important ;
    }

    .title {
        font-family: Milkshake;
        text-shadow:
            -2px -2px 0 white,  
             2px -2px 0 white,
            -2px  2px 0 white,
             2px  2px 0 white;
        margin-bottom: 0.3em;
    }

    .live-box {
        padding-top: 1.5rem !important;
    }

    .dot {
        height: 10px;
        width: 10px;
        border-radius: 50%;
        display: inline-block;
    }
    
    .is-in-top-right-corner {
        position: absolute;
        top: 0.5rem;
        right: 0.75rem;
    }

    .tile {
        height: 65px;
        margin: 5px;
    }

    .icons {
        overflow-x: auto;
    }

    .tile-frame:hover {
        background-color: lightgray !important;
    }
</style>

<style>
    .upload .upload-draggable {
        width: 100% !important;
        padding: 0.5rem !important;
        border: none !important;
        background-color: white;
        border-radius: 20px !important;
        -webkit-transition: background-color 200ms linear;
        -ms-transition: background-color 200ms linear;
        transition: background-color 200ms linear;
    }

    .upload .upload-draggable section {
        -webkit-transition: border-color 200ms linear;
        -ms-transition: border-color 200ms linear;
        transition: border-color 200ms linear;
    }

    .upload .upload-draggable:hover,
    .is-hovered {
        background-color: whitesmoke !important;
    }

    .upload .upload-draggable:hover section,
    .is-hovered section {
        border-color: lightgrey !important;
    }
</style>


